
*- Sample program to demonstrate usage of Super.Lib Date Functions
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD

EXTERNAL ISPART

*- save screen
SAVE SCREEN TO SAMPLE


* draw screen
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("Super.Lib Date Functions",78)
@ 3,1 SAY ""
@ 22,1 SAY ""
@ 23,6 SAY "Drive and Directory.."
@24,46 say "[F1 Help  Alt-F1 Modify Help]"

*- draw the center menu box
SETCOLOR(C_POPCOL)
BXX(5,24,19,52,STANDARD(), 1,7,"         ")
iswait = .f.
do while .t.
     workDate = date()
     work1 = 0
     work2 = 0
     work3 = 0
     work4 = 0

     *- display current drive/directory
     SETCOLOR(C_NORMCOL)
     SCROLL(23,27,23,78,0)
     @23,27 SAY ADDSPACE(curd()+':\'+Curdir(),50)
     SETCOLOR(C_POPCOL)
     set message to 21 Center
     @7,27  PROMPT '1. Begend()          ' message "Determines begin/end of week,month or quarter"
     @8,27  PROMPT '2. Datecalc()        ' message "Adds/subtracts days,weeks,months,years to a date"
     @09,27 PROMPT '3. Daysin()          ' message "Calculates number of days in a month"
     @10,27 PROMPT '4. Doyear()          ' message "Calculates day of the year from date "
     @11,27 PROMPT '5. Dtdiff()          ' message "Returns difference between dates "
     @12,27 PROMPT '6. Dtow()            ' message "Converts date to words "
     @13,27 PROMPT '7. Set_date()        ' message "Sets and restores date format "
     @14,27 PROMPT '8. Getdate()         ' message "Pop-up Calender!"
     @15,27 PROMPT '9. Womonth()         ' message "Calculates week of the month (# of 7 day periods) "
     @16,27 PROMPT '0. Woyear()          ' message "Calculates week of the year (# of 7 day periods) "
     @18,27 PROMPT 'Quit                 ' message "Miller time..."
     menu to sf_choice
     do case
        CASE m->sf_CHOICE = 1         &&      '1. Begend()
            datebox = makebox(5,10,20,75)
            DO WHILE .T.
               SCROLL(6,11,19,74,0)
               @7,12 say "Current DATE being used is         :" get workdate
               read
               begend = 0
               ranger = 1
               @10,12 say "Beginning (1) or end(0)           :" get begend pict "9" valid genval("begend=0.or. begend=1","Must be 0 or 1")
               @11,12 say "of Week (1) Month (2) Quarter (3) :" get ranger pict "9" valid genval("ispart(ranger,1,2,3)","Must be 1,2 or3")
               read
               if ranger=1  && week
                   doweek = iif(begend=1,1,7)
                   @13,12 say "Day of week "+IIF(begend=1,"beginning","ending")+" of week falls on"
                   @14,12 say "where Sunday=1                :" get doweek pict "9" valid genval("ispart(doweek,1,2,3,4,5,6,7)","Must be 1-7 (unless you've got longer weeks than I do!)")
                   read
                   result = BEGEND(workdate,begend,ranger,doweek)
               else
                   result = BEGEND(workdate,begend,ranger)
               endif
               MSG("Result of obtaining "+iif(begend=1,"Beginning of ","End of ")+takeout("Week:Month:Quarter",":",ranger),;
                   "",;
                   "for the source date  :"+dtow(workdate),;
                   "",;
                   "is                   :"+dtow(result),;
                   "")
               IF !MESSYN("Try another one?")
                   exit
               endif
            ENDDO
            unbox(datebox)
        CASE m->sf_CHOICE = 2         &&      '2. Datecalc()
            datebox = makebox(5,10,20,75)
            DO WHILE .T.
               SCROLL(6,11,19,74,0)
               @7,12 say "Current DATE being used is         :" get workdate
               read
               ptype = 1
               numberof = 1
               @8,12 say  "Add/subtract:"
               @9,12 say  "(1)Days (2)Weeks (3)Months (4)Years      :" get ptype pict "9" valid genval("ispart(ptype,1,2,3,4)","Must be 1-4 ")
               @10,12 say "How many ? (use negative to subtract)    :" get numberof pict "9999"
               read
               result = DATECALC(workdate,numberof,ptype)
               MSG("Result of adding    "+trans(numberof,"9999")+takeout("Days:Weeks:Months:Years",":",ptype),;
                   "",;
                   "to the source date  :"+dtow(workdate),;
                   "",;
                   "is                  :"+dtow(result),;
                   "")

               IF !MESSYN("Try another one?")
                   exit
               endif
            ENDDO
            unbox(datebox)
        CASE m->sf_CHOICE = 3         &&      '3. Daysin()
            popread(.f.,"Current DATE being used is ",@workdate,"")
            msg("Days in the month in which "+dtoc(workdate)+" falls:"+trans(daysin(workdate),"99"))
        CASE m->sf_CHOICE = 4         &&      '4. Doyear()
            popread(.f.,"Current DATE being used is ",@workdate,"")
            msg("Day of the year of "+dtoc(workdate)+" :  "+trans(doyear(workdate),"999")+"  ")
        CASE m->sf_CHOICE = 5         &&      '5. Dtdiff()
            datebox = makebox(5,10,20,75)
            DO WHILE .T.
               SCROLL(6,11,19,74,0)
               firstdate = date()
               oldate = set_date(1)
               secdate   = ctod("12/21/87")
               set_date(oldate)
               diffin    = 1
               @10,12 say "First Date                             :" get firstdate
               @11,12 say "2nd Date                               :" get secdate
               @13,12 say "Difference in (1)Days (2)Whole weeks "
               @14,12 say "              (3)Months (4)Whole years :" get diffin pict "9" valid genval("ispart(diffin,1,2,3,4)","Must be 1-4 ")
               read
               result = DTDIFF(firstdate,secdate,diffin)
               MSG("Difference between  "+dtoc(firstdate)+" and "+dtoc(secdate),;
                   "in "+takeout("Days:Weeks:Months:Years",":",diffin),;
                   "",;
                   "  =   :"+trans(DTDIFF(firstdate,secdate,diffin),"999999"),;
                   "")

               IF !MESSYN("Try another one?")
                   exit
               endif
            ENDDO
            unbox(datebox)
        CASE m->sf_CHOICE = 6         &&      '6. Dtow()
            popread(.f.,"Current DATE being used is ",@workdate,"")
            msg("Date to Words of "+dtoc(workdate)+":",dtow(workdate))
        CASE m->sf_CHOICE = 7         &&      '7. Set_date()
            datebox = makebox(5,10,20,75)
            oldate = set_date(1)
            @8,12 prompt "1  American        "+dtoc(workdate)
            set_date(2)
            @9,12 prompt "2  British/French  "+dtoc(workdate)
            set_date(3)
            @10,12 prompt "3  German          "+dtoc(workdate)
            set_date(4)
            @11,12 prompt "4  ANSI            "+dtoc(workdate)
            set_date(5)
            @12,12 prompt "5  Italian         "+dtoc(workdate)
            menu to set_to
            if set_to > 0
              set_date(set_to)
            else
              set_date(oldate)
            endif
            unbox(datebox)
        CASE m->sf_CHOICE = 8         &&      '8. getdate()
            getdate()
        CASE m->sf_CHOICE = 9         &&      '9. Womonth()
            popread(.f.,"Current DATE being used is ",@workdate,"")
            msg("Week of the month of "+dtoc(workdate)+" :  "+trans(womonth(workdate),"9")+"  ")
        CASE m->sf_CHOICE = 10        &&      '0. Woyear()
            popread(.f.,"Current DATE being used is ",@workdate,"")
            msg("Week of the year of "+dtoc(workdate)+" :  "+trans(woyear(workdate),"99")+"  ")
        CASE m->sf_CHOICE = 11 .or. m->sf_choice = 0  && quit
     exit
     endcase
enddo
UNBOX(SAMPLE,0,0,24,79)


