
*- Sample program to demonstrate usage of Super.Lib String Functions
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD

*- save screen
SAVE SCREEN TO SAMPLE


* draw screen
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("Super.Lib String Functions",78)
@ 3,1 SAY ""
@ 22,1 SAY ""
@ 23,6 SAY "Drive and Directory.."
@24,46 say "[F1 Help  Alt-F1 Modify Help]"

*- draw the center menu box
SETCOLOR(C_POPCOL)
BXX(5,24,19,52,STANDARD(), 1,7,"         ")
iswait = .f.
set message to 21 Center
do while .t.
     workstring = addspace("Super.Lib Professional ",60)
     work1 = 0
     work2 = 0
     work3 = 0
     work4 = 0

     *- display current drive/directory
     SETCOLOR(C_NORMCOL)
     SCROLL(23,27,23,78,0)
     @23,27 SAY ADDSPACE(curd()+':\'+Curdir(),50)
     SETCOLOR(C_POPCOL)

     @7,27  PROMPT '1. Addspace()        ' message centr("Pads string with spaces                         ")
     @8,27  PROMPT '2. Allbut()          ' message "Returns all but last x characters"
     @09,27 PROMPT '3. Arrange()         ' message "Rearranges text in a string"
     @10,27 PROMPT '4. Centr()           ' message "Centers a string in x spaces"
     @11,27 PROMPT '5. Crunch()          ' message "Moves spaces in a string to end of string"
     @12,27 PROMPT '6. Ljust()           ' message "Left justifies a string"
     @13,27 PROMPT '7. Proper()          ' message "Capitalizes first letters of string, lowers rest"
     @14,27 PROMPT '8. Rjust()           ' message "Right justifies a string"
     @15,27 PROMPT '9. Stretch()         ' message "Imbeds characters in a string"
     @16,27 PROMPT '0. Strpull()         ' message "Extract text between 2 characters"
     @18,27 PROMPT 'Quit                 ' message "Bye !"
     menu to sf_choice
     do case
        CASE m->sf_CHOICE = 1    && ADDSPACE()
               popread(.t.,"Starting string:",@workstring,"@K")
               work1 = len(workstring)
               popread(.t.,"Pad string with # spaces ",@work1,"99")
               msg("String is now:",left(addspace(workstring,work1),70))
        CASE m->sf_CHOICE = 2    && ALLBUT()
              popread(.t.,"Starting string:",@workstring,"@K")
              stringbox = makebox(5,2,15,78)
              do while .t.
                work1  = 1
                work2  = 1
                @6,3  say "String=>"+addspace(workstring,60)
                work1 = len(workstring)
                @8,3 say  "(Maximum "+trans(m->work1,"999")+")"
                @10,3 say "How many characters from the right? ";
                  GET m->work2  PICT REPL("9",len(trim(str(work1))))
                @14,3 say "[ Press ESCAPE when done diddling]"
                READ
                if lastkey() = 27
                  exit
                endif
                workstring = allbut(m->workstring,work2)
              enddo
              unbox(m->stringbox)
        CASE m->sf_CHOICE = 3    && ARRANGE()
              popread(.t.,"Starting string:",@workstring,"@K")
              stringbox = makebox(5,2,15,78)
              do while .t.
                @6,3  say "String=>"+addspace(workstring,60)
                work1  = 1
                work2  = 1
                work3  = 1
                @8,3 SAY "Starting at position        :" GET m->work1 PICT "99"
                @9,3  SAY "Extract how many characters :" GET m->work2 PICT "99"
                @10,3 say " (0 for REST) "
                @11,3 say "And move them to position   :" GET m->work3  PICT"99"
                @12,3 say " (0 for BEGINNING, 99 for END) "
                @14,3 say "[ Press ESCAPE when done diddling]"
                READ
                if lastkey() = 27
                  exit
                endif
                workstring = arrange(m->workstring,work1,work2,work3)
              enddo
              unbox(m->stringbox)

        CASE m->sf_CHOICE = 4    && CENTR()
              popread(.t.,"Starting string:",@workstring,"@K")
               work1 = len(workstring)
               popread(.t.,"Center string in how many spaces ?",@work1,"99")
               msg("String is now:",left(CENTR(workstring,work1),70))
        CASE m->sf_CHOICE = 5    && CRUNCH()
              popread(.t.,"Starting string:",@workstring,"@K")
               IF MESSYN("String:"+workstring,"Move all spaces to right end ",;
                         "Move all but single spaces to right end")
                    workstring = CRUNCH(m->workstring,0)
               ELSE
                    workstring = CRUNCH(m->workstring,1)
               ENDIF
               msg("String is now:",left(workstring,70))
        CASE m->sf_CHOICE = 6    && LJUST()
              popread(.t.,"Starting string:",@workstring,"@K")
              msg(workstring,"    left justified = ",ljust(workstring))

        CASE m->sf_CHOICE = 7    && PROPER()
              popread(.t.,"Starting string:",@workstring,"@K")
              msg(workstring,"    properized = ",proper(workstring))
        CASE m->sf_CHOICE = 8    && RJUST()
              popread(.t.,"Starting string:",@workstring,"")
              msg(workstring,"    right justified = ",rjust(workstring))
        CASE m->sf_CHOICE = 9    && STRETCH()
              stringbox = makebox(5,2,15,78)
              do while .t.
                workstring = left(workstring,60)
                popread(.t.,"Starting string:",@workstring,"@K")
                @6,3  say "String=>"+addspace(workstring,60)
                work1 = 1
                work2 = " "
                @8,3 SAY "Insert every how many characters    :" ;
                  GET m->work1 PICT "9"
                @9,3 SAY "Character(s) to use (default = SPACE) :" ;
                  GET m->work2
                READ
                if lastkey() = 27
                  exit
                endif
                workstring = STRETCH(m->workstring,m->work2,m->work1)
              enddo
              unbox(m->stringbox)
        CASE m->sf_CHOICE = 10   && STRPULL()
              popread(.t.,"Starting string:",@workstring,"@K")
              WORK1 = "f"
              WORK2 = "s"
              popread(.t.,"Between letters ",@work1,"","           and",@work2,"")
              WORKSTRING = STRPULL(workstring,work1,work2)
              msg("String is now =>",workstring)
        CASE m->sf_CHOICE = 11 .or. m->sf_choice = 0  && quit
	    exit
     endcase
enddo
UNBOX(SAMPLE,0,0,24,79)


