
*- Sample program to demonstrate usage of VIEWPORT()
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD

*- save screen
SAVE SCREEN TO SAMPLE


*- initialize some variables
DECLARE INDEXES[8]
AFILL(m->indexes,"")
usedbf = ""

* draw screen
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("VIEWPORT",78)
@ 3,1 SAY ""
@ 19,1 SAY ""
@ 20,6 SAY "Using Datafile......."
@ 21,6 SAY "Indexes Open........."
@ 23,6 SAY "Drive and Directory.."
@24,46 say "[F1 Help  Alt-F1 Modify Help]"

*- draw the center menu box
SETCOLOR(C_POPCOL)
BXX(5,24,16,52,STANDARD(), 1,7,"         ")

do while .t.

     *- display current drive/directory, dbfs and indexes
     SETCOLOR(C_NORMCOL)
     SCROLL(20,27,23,78,0)
     n_recs =IIF(USED(),' Containing '+Alltrim(STR(RECC()))+' RECORDS','')
     @20,27 SAY  ALIAS()+m->n_recs
     @21,27 say indexes[1]+" "+indexes[2]+" "+indexes[3]+" "+indexes[4]
     @22,27 say indexes[5]+" "+indexes[6]+" "+indexes[7]+" "+indexes[8]
     @23,27 SAY ADDSPACE(curd()+':\'+Curdir(),50)
     SETCOLOR(C_POPCOL)

     @7,27  PROMPT 'Change Directory     '
     @9,27  PROMPT 'Select DBF File      '
     @11,27 PROMPT 'Open Index File(s)   '
     @13,27 PROMPT 'VIEWPORT             '
     @15,27 PROMPT 'Quit                 '
     menu to sf_choice
     do case
	CASE m->sf_CHOICE = 1	 && change drive/directory
	    * check for change drive
	    OLDRIVE  = CURD()
	    CURDRIVE = m->oldrive
	    POPREAD(.f.,"Use Drive  :",@CURDRIVE,"!")
	    if !m->curdrive==m->oldrive
	      NEWDRV(m->curdrive)
	    endif
	    * run directory changer
	    IF FULLDIR()
	       USE
	    ENDIF

	CASE m->sf_CHOICE = 2	 && select DBF files
	    * if there are dbf files, get a picklist of them
	    if adir("*.dbf") > 0
		USEDBF = POPEX("*.DBF","Select DBF")
		if !empty(m->usedbf)
			USE (m->usedbf)
		endif
	    else
		*- message to user
		MSG("No DBFs detected in ",curd()+":\"+curdir())
	    endif

	CASE m->sf_CHOICE = 3	 && open index files
	   *- must be a dbf open and indexes present
	   if USED() .and. (ADIR('*'+Indexext())>0)
	      * pickndx will fill an array with selected indexes
	      PICKNDX(m->indexes)

	      * openind will open indexes in an array
	      OPENIND(m->indexes)
	   elseif !USED()
	       *- deliver a message
	       MSG("Select a DBF file first")
	   else
	       MSG("No index files present with extension: "+indexext())
	   endif

	CASE m->sf_CHOICE = 4	 && xxxxxxxxxxxxxxxxx
	    *- make sure a dbf is open
	    if USED()
	       * setup for viewport
	       * I'm just filling with the defaults here, as the dbf
	       * structure is unknown, but you can use this shell

	       private flds[fcount()]  && fields array
	       private fdes[fcount()]  && field description array
	       private fpic[fcount()]  && field picture array
	       private fval[fcount()]  && field valids array
	       private floo[fcount()]  && field lookups array
	       private fedit[fcount()] && display/edit array

	       afields(flds)	       && fill fields array
	       afields(fdes)	       && fill field description array
	       afill(fpic,"")          && fill field picture array
	       afill(fval,"")          && fill field valid array
	       afill(floo,"")          && fill field lookup array
	       afill(fedit,.t.)        && fill display/edit array

	       *- 'other' menu array
               private others[6]
	       others[1] = "1 Read This PRG;FILEREAD(1,1,23,79,'sfview.prg')"
	       others[2] = "2 Tabular Edit/Add;EDITDB(.t.)"
	       others[3] = "3 Popup Calender;GETDATE()"
	       others[4] = "4 TODO List;TODOLIST()"
               others[5] = "5 Sum dbf field;SUM_AVE('SUM')"
               others[6] = "6 Average dbf field;SUM_AVE('AVE')"
               EXTERNAL FILEREAD, EDITDB, GETDATE, TODOLIST, SUM_AVE

	       VIEWPORT(.t.,flds,fdes,fpic,fval,floo,others,fedit)
	    else
	       *- deliver a message
	       MSG("Select a DBF file first")
	    endif
	CASE m->sf_CHOICE = 5  .or. m->sf_choice = 0  && quit
	    CLOSE ALL
	    exit
     endcase
enddo
UNBOX(SAMPLE,0,0,24,79)





